# Reference Documentation

This is the reference documentation for Gerbil.
We aim to exhaustively document the core prelude, runtime builtins, and the standard library.

Nonetheless, we will not (re)document core Scheme and Gambit provided primitives, as there
is already extensive high quality documentation for these topics:
- For documentation pertaining to core Scheme primitives, see
  [R5RS](https://schemers.org/Documents/Standards/R5RS/HTML/)
- For documentation pertaining to Gambit provided primitives, see the
  [Gambit Manual](https://www.iro.umontreal.ca/~gambit/doc/gambit.html).

If any part of this documentation is missing, out of date, or unclear, it's a bug;
we know there are lots of such bugs, but if any one such bug bothers you particularly,
contact us (by email, on IRC, etc.) to fix it, and we'll prioritize documenting
those parts that are in demand.

You too can help by submitting missing documentation, even if you don't fully understand how it works:
stating your misunderstanding can help us discover which aspects deserve more explanations,
and whatever you propose can be a great starting point that we can fix and complete.
